using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace Components
{
	/// <summary>
	/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
	/// 
	/// UserControl Objekt das Filtermglichkeit bietet
	/// 
	/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
	/// </summary>
	public class DataGridFilterTextBoxes : System.Windows.Forms.UserControl
	{
		private DataTable _dataSource = null;
		
		// Fr das Drag and Drop der Spalte!
		private bool dragAndDrop = false;
		private int dragStartColumn = 0;

		// Konstante fr den X Offset Start der Textboxen
		private const int TEXTBOXES_XPOSI_OFFSET = 2;

		// InitialisierungsWert der Textboxen!
		private const string TEXTBOXES_DEFAULT_VALUE = "";
		
		// Public DataGrid damit man von aussen bentzen kann
		public MyPublicDataGrid dataGridFilter;
		
		private System.Windows.Forms.TextBox[] textBoxes;
		private System.Windows.Forms.Panel panel1;

		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DataGridFilterTextBoxes()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataGridFilter = new Components.MyPublicDataGrid();
			this.panel1 = new System.Windows.Forms.Panel();
			((System.ComponentModel.ISupportInitialize)(this.dataGridFilter)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGridFilter
			// 
			this.dataGridFilter.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.dataGridFilter.BackgroundColor = System.Drawing.Color.Silver;
			this.dataGridFilter.CaptionVisible = false;
			this.dataGridFilter.DataMember = "";
			this.dataGridFilter.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGridFilter.Location = new System.Drawing.Point(0, 18);
			this.dataGridFilter.Name = "dataGridFilter";
			this.dataGridFilter.Size = new System.Drawing.Size(336, 342);
			this.dataGridFilter.TabIndex = 0;
			this.dataGridFilter.MouseDown += new System.Windows.Forms.MouseEventHandler(this.dataGridFilter_MouseDown);
			this.dataGridFilter.Paint += new System.Windows.Forms.PaintEventHandler(this.refreshTextBoxes);
			this.dataGridFilter.Scroll += new System.EventHandler(this.dataGridFilter_Scroll);
			this.dataGridFilter.MouseUp += new System.Windows.Forms.MouseEventHandler(this.dataGridFilter_MouseUp);
			// 
			// panel1
			// 
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(3500, 20);
			this.panel1.TabIndex = 2;
			// 
			// DataGridExtended
			// 
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.dataGridFilter);
			this.Name = "DataGridExtended";
			this.Size = new System.Drawing.Size(336, 360);
			this.Load += new System.EventHandler(this.FilterDataGrid_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataGridFilter)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion


		/// <summary>
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// 
		/// Methode die die Textboxen neu generiert am TabellenKopf (DataGrid: dataGridFilter)
		/// 
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// </summary>
		/// <param name="sender">Sender des Events</param>
		/// <param name="e">2.Argument muss PaintEventArgs sein, da die Paint-Methode vom DataGrid "berladen" wird</param>
		private void refreshTextBoxes(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			try
			{
				//TODO: Panel resizen auf variable Grsse abhngig vom DataGrid und nicht einfach auf fixe GROSSE Grsse setzen


				// die Textboxen das 1.Mal erzeugen
				if (this.textBoxes == null)
				{
					int anzahlTextBoxes = dataGridFilter.TableStyles[0].GridColumnStyles.Count;

					//Textfelder generieren anhngig vom Datagrid: dataGridFilter
					this.textBoxes = new TextBox[anzahlTextBoxes];

					// keine Textboxes da! -> neue kreieren
					for (int lauf = 0; lauf < anzahlTextBoxes; lauf++)
					{
						this.textBoxes[lauf] = new System.Windows.Forms.TextBox();
						this.panel1.Controls.Add(this.textBoxes[lauf]);
						this.textBoxes[lauf].Text = TEXTBOXES_DEFAULT_VALUE;
						
						// Events berladen
						this.textBoxes[lauf].Enter += new System.EventHandler(this.textBoxes_Enter);
						this.textBoxes[lauf].Leave += new System.EventHandler(this.textBoxes_Leave);
						
					}
				}

				// TODO: Start X-Position von Border abhngig machen
				int xPosition = TEXTBOXES_XPOSI_OFFSET;

				if (dataGridFilter.TableStyles[0].RowHeadersVisible)
					xPosition += dataGridFilter.TableStyles[0].RowHeaderWidth;
                    

				//Console.WriteLine("anzahlTextBoxes: " +anzahlTextBoxes);

				for ( int lauf=0; lauf < textBoxes.Length ; lauf ++)
				{
					this.textBoxes[lauf].Location = new System.Drawing.Point(xPosition, 0);
					this.textBoxes[lauf].Width = dataGridFilter.TableStyles[0].GridColumnStyles[lauf].Width;
					this.textBoxes[lauf].Name = "textBox" + lauf;
					this.textBoxes[lauf].TabIndex = lauf;

					this.textBoxes[lauf].BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
					xPosition += dataGridFilter.TableStyles[0].GridColumnStyles[lauf].Width;
					
				}//for schleife
			}
			catch (Exception ex)
			{
				System.Console.WriteLine("Sender: " +  sender.ToString() + "  ExceptionType: " + ex.GetType() + "  Message: " + ex.Message);
			}

		}


		/// <summary>
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// 
		/// Filter auf das DataGrid.Datasource setzen abhngig von den TextBoxen
		/// 
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// </summary>
		private void setFilterFromTextBox()
		{
			try
			{
				string newFilter = "1=1 ";
				string tbxFilter = "";
				for ( int lauf=0; lauf < textBoxes.Length  ; lauf ++)
				{

					tbxFilter = "";
					if ( ! (textBoxes[lauf].Text == ""  | textBoxes[lauf].Text == "**") )
						tbxFilter = " AND CONVERT(" + dataGridFilter.TableStyles[0].GridColumnStyles[lauf].MappingName + ", 'System.String') LIKE '*" +  textBoxes[lauf].Text + "*' " ;
					
					newFilter = newFilter + tbxFilter;
				}

				//dataset11.Tables[0].DefaultView.RowFilter = newFilter;
				((DataTable)dataGridFilter.DataSource).DefaultView.RowFilter = newFilter;
				
				// Diese Zuweisung braucht es nur wenn DataMember vom DataGrid gesetzt isch
				// dataGridFilter.DataSource = ((DataTable)dataGridFilter.DataSource).DefaultView;

				// Console.WriteLine("DEBUG Filter: " + newFilter);
			}
			catch (Exception ex)
			{
				System.Console.WriteLine("ExceptionType: " + ex.GetType() + "  Message: " + ex.Message);			
			}
		}



		/// <summary>
		/// 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void FilterDataGrid_Load(object sender, System.EventArgs e)
		{
			if ( DataSource != null )
			{
				//Console.WriteLine("DEBUG: DataSource: " + DataSource.ToString() );
				this.dataGridFilter.DataSource = DataSource;
			}

			refreshTextBoxes(sender, null);
		}


		/// <summary>
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// Statistik anzeigen ber das Datagrid
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void button1_Click(object sender, System.EventArgs e)
		{
			//Infomeldung ber das Datagrid ausgeben!!
			string infoStr = "Visible Rows: "+ dataGridFilter.VisibleRowCount.ToString();
			infoStr += "\nVisible Cols: "+ dataGridFilter.VisibleColumnCount.ToString();
			//infoStr += "\nTotal Rows: "+ dataset11.Tables[0].Rows.Count.ToString();
			//infoStr += "\nTotal Cols: "+ dataset11.Tables[0].Columns.Count.ToString();		
			
			// Get all table styles in the Grid and Column Styles
			// which returns table and column names
			foreach(DataGridTableStyle gridStyle in dataGridFilter.TableStyles)
			{
				infoStr += "\nTable Name: "+ gridStyle.MappingName;
				foreach(DataGridColumnStyle colStyle in gridStyle.GridColumnStyles)
				{
					infoStr += "\n Column #" +colStyle.MappingName;
				}
			}
			MessageBox.Show(infoStr);
		}


		/// <summary>
		/// Wenn im Datagrid gescrollt wird, muss das Panel mit Textboxen verschoben werden
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void dataGridFilter_Scroll(object sender, System.EventArgs e)
		{
			//Scrolling innerhalb der Tabelle --> Textboxen neu "malen"
			this.panel1.Location = new System.Drawing.Point( -dataGridFilter.HScrollBar.Value , 0);

		}


		/// <summary>
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// 
		/// Methode bewegt eine Column from ---> to
		/// 
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// </summary>
		/// <param name="_dataGrid">DataGrid das betroffen ist</param>
		/// <param name="_mappingName">MappingName</param>
		/// <param name="fromCol">welche Spalte woher</param>
		/// <param name="toCol">welceh Spalte wohin</param>
		public void MoveColumn(DataGrid _dataGrid, int mappingTable, int fromCol, int toCol) 
		{ 
			// nur wenn Zeil und Quelle ungleich sind durchfhren
			if(fromCol != toCol) 
			{
				
				DataGridTableStyle oldTS = _dataGrid.TableStyles[mappingTable]; 
				DataGridTableStyle newTS = new DataGridTableStyle(); 
				newTS.MappingName = _dataGrid.TableStyles[mappingTable].MappingName; 
				
				
				// TextBox Array vertauschen!
				TextBox[] newBoxes = new TextBox[textBoxes.Length];
				
				int lauf = 0;
				// GridColumnStyles und TextBox Array austauschen!
				for(int i = 0; i < oldTS.GridColumnStyles.Count; ++i) 
				{ 
					if(i != fromCol && fromCol < toCol) 
					{
						newTS.GridColumnStyles.Add(oldTS.GridColumnStyles[i]); 
						newBoxes[lauf] = textBoxes[i];
						lauf ++;
					}
					if(i == toCol) 
					{
						newTS.GridColumnStyles.Add(oldTS.GridColumnStyles[fromCol]); 
						newBoxes[lauf] = textBoxes[fromCol];
						lauf ++;
					}
					if(i != fromCol && fromCol > toCol) 
					{
						newTS.GridColumnStyles.Add(oldTS.GridColumnStyles[i]);      
						newBoxes[lauf] = textBoxes[i];
						lauf ++;
					}
					
				} 
				textBoxes = newBoxes;
				_dataGrid.TableStyles.Remove(oldTS); 
				_dataGrid.TableStyles.Add(newTS); 

				

				refreshTextBoxes(null,null);


			}


		} 
 


		/// <summary>
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// 
		/// Methode kontrolliert ob die ausgewhlte Textbox angezeigt wird.
		/// realisiert dass die gewhlte TextBox sicher angezeigt wird
		/// 
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void textBoxes_Enter(object sender, System.EventArgs e)
		{
			TextBox temp = (TextBox) sender;
			int scrollValue = dataGridFilter.HScrollBar.Value;

			/*
			Console.WriteLine("DEBUG: Scrollbar Value FORHER: " + dataGridFilter.HScrollBar.Value );
			Console.WriteLine("DEBUG: BOX   xPosi: " + temp.Location.X  + "   Breite: " + temp.Width );
			Console.WriteLine("DEBUG: PANEL xPosi: " + this.panel1.Location.X  + "   Breite: " + this.panel1.Width );
			Console.WriteLine("DEBUG: UCONT xPosi: " + dataGridFilter.Location.X  + "   Breite: " + this.Size.Width);
			*/

			// rechte Ecke innerhalb des Anzeigebereiches?
			if ( temp.Location.X + this.panel1.Location.X  + temp.Width > dataGridFilter.Width )
			{
				//Console.WriteLine("DEBUG: Rechte Ecke Grsser");
				scrollValue = scrollValue - ( dataGridFilter.Width - temp.Location.X - this.panel1.Location.X  - temp.Width ) ;
				//dataGridFilter.HScrollBar.Maximum;
				// Console.WriteLine("Breite: " + dataGridFilter.HScrollBar.Maximum);

				//Console.WriteLine("DEBUG: Scrollbar Value NACHHER: " + dataGridFilter.HScrollBar.Value );			
				dataGridFilter.HScrollBar.Value = scrollValue;
			
				// Datengrid verschieben, da danach auf dem berechnet wird
				dataGridFilter.setHorizScrollBarX(dataGridFilter.HScrollBar.Value );

			}


			// linke Ecke innerhalb des Anzeigebereiches?
			if ( temp.Location.X + this.panel1.Location.X < dataGridFilter.Location.X )
			{
				//Console.WriteLine("DEBUG: Linke Ecke Kleiner");
				scrollValue = scrollValue + ( temp.Location.X + this.panel1.Location.X ) ;


				//Console.WriteLine("DEBUG: Scrollbar Value NACHHER: " + dataGridFilter.HScrollBar.Value );			
				dataGridFilter.HScrollBar.Value = scrollValue;


			}
			
			//Console.WriteLine("DEBUG: Scrollbar Value Wert: " + scrollValue );

			dataGridFilter.setHorizScrollBarX(dataGridFilter.HScrollBar.Value );
			dataGridFilter.HScrollBar.Refresh(); 
		}


		private void textBoxes_Leave(object sender, System.EventArgs e)
		{
			//Filter neu setzen beim Verlassen der Textboxen
			setFilterFromTextBox();
		}



		/// <summary>
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// 
		/// Methode realisiert das Drag&Drop der Spalten
		/// 
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void dataGridFilter_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			dragAndDrop = false;
			
			//dataGridFilter.AllowSorting = false;

			// Spalte ausrechnen ber welcher geklickt wurde

			// Schauen ob in Spaltennamen geklickt wurde!
			Point pt = new Point(e.X, e.Y);
			DataGrid.HitTestInfo hti = dataGridFilter.HitTest(pt);  

			// Links geklickt?
			if(e.Button == MouseButtons.Left)
			{			
				// Console.WriteLine("DEBUG: MouseDown. Typ: " + hti.Type );

				// auf Columnheader geklickt?
				if(hti.Type == DataGrid.HitTestType.ColumnHeader)  
				{  
					//Console.WriteLine ("DEBUG: StartCol: " + hti.Column );
					dragStartColumn = hti.Column;
					Cursor = Cursors.Hand;
					//Mausposition speichern und speichern dass jetzt gedroppt wird
					dragAndDrop = true;
					// Console.WriteLine("DEBUG: dragAndDrop = true" );
				}
			}


		}


		
		/// <summary>
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// 
		/// Methode realisiert das Drag&Drop der Spalten
		/// 
		/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void dataGridFilter_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			//dataGridFilter.AllowSorting = true;

			if (dragAndDrop == true)
			{
				// Schauen ob in Spaltenkopf geklickt wurde!
				Point pt = new Point(e.X, e.Y);

				DataGrid.HitTestInfo hti = dataGridFilter.HitTest(pt);  
				
				//Console.WriteLine("DEBUG: MouseUP auf Columnheader! Typ: " + hti.Type );

				// Links geklickt?  auf Columnheader geklickt?
				if(e.Button == MouseButtons.Left && hti.Type == DataGrid.HitTestType.ColumnHeader)
				{			
					// Console.WriteLine("DEBUG: MouseUP auf Columnheader! Typ: " + hti.Type );
					// Console.WriteLine ("DEBUG: EndCol: " + hti.Column );
					if ( hti.Column != dragStartColumn )
					{
						MoveColumn(dataGridFilter, 0, dragStartColumn, hti.Column ); 
						// Console.WriteLine ("MoveColumn!" );
					}
				}
				Cursor = Cursors.Default;
			}
		}



		public DataTable DataSource
		{
			get
			{
				return _dataSource;
			}
			set
			{
				_dataSource = value;
			}
		
		}




	}


	/// <summary>
	/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
	/// 
	/// Scrollbars: PROTECTED --> PUBLIC
	/// 
	/// Diese Klasse braucht es um die PROTECTED Eigenschaften der Scrollbars PUBLIC zu machen
	/// 
	/// _.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`._.`. 
	/// </summary>
	public class MyPublicDataGrid : System.Windows.Forms.DataGrid
	{
		public MyPublicDataGrid()
		{
			
		}

		public ScrollBar HScrollBar
		{
			get
			{
				return HorizScrollBar;
			}
			set 
			{
				HorizScrollBar.Value = value.Value;
			}
		} 

		public void setHorizScrollBarX(int x)
		{
			this.GridHScrolled(this, new
				ScrollEventArgs(System.Windows.Forms.ScrollEventType.LargeIncrement,
				x));
		} 


		public ScrollBar VScrollBar
		{
			get
			{
				return VertScrollBar;
			}
			set
			{
				VertScrollBar.Value = value.Value;
			}
		}




	}

}
